// ignore_for_file: use_build_context_synchronously
import 'dart:convert';
import 'package:provider/provider.dart';
import '../Basicp2_viewModel/Basicp2_view_model_screen.dart';
import '../../../../utils/image_constant.dart';
import '../../../../utils/size_utils.dart';
import '../../../../theme/app_style.dart';
import '../../../../widgets/app_bar/appbar_image.dart';
import '../../../../widgets/app_bar/appbar_title.dart';
import '../../../../widgets/app_bar/custom_app_bar.dart';
import 'package:barcode_widget/barcode_widget.dart';
import 'package:fluttertoast/fluttertoast.dart';
import '../../../../widgets/custom_button.dart';
import '../../../../widgets/custom_text_form_field.dart';
import 'package:flutter/material.dart';
import 'package:autocomplete_textfield/autocomplete_textfield.dart';
import 'package:qr_flutter/qr_flutter.dart';
import 'package:intl/intl.dart';

import 'dart:math';
import '../../../../Reuseable/reusable_text_field.dart';
import '../../../../Reuseable/reusable_date_picker_field.dart';
import '../../../../Reuseable/reusable_date_time_picker_field.dart';
import '../../../../Reuseable/reusable_dropdown_field.dart';
import 'package:flutter/services.dart';
class basicp2UpdateEntityScreen extends StatefulWidget {
    final Map<String, dynamic> entity;


  basicp2UpdateEntityScreen({required this.entity});

  @override
  _basicp2UpdateEntityScreenState createState() => _basicp2UpdateEntityScreenState();
}

class _basicp2UpdateEntityScreenState extends State<basicp2UpdateEntityScreen> {
  final _formKey = GlobalKey<FormState>();





TextEditingController date_field = TextEditingController(); 
DateTime selectedDatedate_field = DateTime.now();

Future<void> _selectDatedate_field(BuildContext context) async {
  final DateTime? picked = await showDatePicker(
    context: context,
    initialDate: selectedDatedate_field,
    firstDate: DateTime(2000),
    lastDate: DateTime(2101),
  );
  print(picked);
  if (picked != null && picked != selectedDatedate_field) {
    setState(() {
      selectedDatedate_field = picked;
    });
  }
}

TextEditingController date_field2 = TextEditingController(); 
DateTime selectedDatedate_field2 = DateTime.now();

Future<void> _selectDatedate_field2(BuildContext context) async {
  final DateTime? picked = await showDatePicker(
    context: context,
    initialDate: selectedDatedate_field2,
    firstDate: DateTime(2000),
    lastDate: DateTime(2101),
  );
  print(picked);
  if (picked != null && picked != selectedDatedate_field2) {
    setState(() {
      selectedDatedate_field2 = picked;
    });
  }
}

DateTime selectedDateTimedatetime_field = DateTime.now();
TextEditingController datetime_field = TextEditingController();
Future<void> _selectDateTimedatetime_field(BuildContext context) async {
  final DateTime? picked = await showDatePicker(
    context: context,
    initialDate: selectedDateTimedatetime_field,
    firstDate: DateTime(2000),
    lastDate: DateTime(2101),
  );

  if (picked != null) {
    final TimeOfDay? pickedTime = await showTimePicker(
      context: context,
      initialTime: TimeOfDay.fromDateTime(selectedDateTimedatetime_field),
    );
    print(pickedTime);
    if (pickedTime != null) {
      setState(() {
        selectedDateTimedatetime_field = DateTime(
          picked.year,
          picked.month,
          picked.day,
          pickedTime.hour,
          pickedTime.minute,
        );
      });
    }
  }
}

DateTime selectedDateTimedatetime_field2 = DateTime.now();
TextEditingController datetime_field2 = TextEditingController();
Future<void> _selectDateTimedatetime_field2(BuildContext context) async {
  final DateTime? picked = await showDatePicker(
    context: context,
    initialDate: selectedDateTimedatetime_field2,
    firstDate: DateTime(2000),
    lastDate: DateTime(2101),
  );

  if (picked != null) {
    final TimeOfDay? pickedTime = await showTimePicker(
      context: context,
      initialTime: TimeOfDay.fromDateTime(selectedDateTimedatetime_field2),
    );
    print(pickedTime);
    if (pickedTime != null) {
      setState(() {
        selectedDateTimedatetime_field2 = DateTime(
          picked.year,
          picked.month,
          picked.day,
          pickedTime.hour,
          pickedTime.minute,
        );
      });
    }
  }
}

bool _isemail_fieldEmailValid = true;

void _validateemail_fieldEmail(String email) {
  setState(() {
    _isemail_fieldEmailValid = RegExp(r'^[\\w-]+(\\.[\\w-]+)*@[\\w-]+(\\.[\\w-]+)+$').hasMatch(email);
  });
}

bool _isemail_field2EmailValid = true;

void _validateemail_field2Email(String email) {
  setState(() {
    _isemail_field2EmailValid = RegExp(r'^[\\w-]+(\\.[\\w-]+)*@[\\w-]+(\\.[\\w-]+)+$').hasMatch(email);
  });
}




  @override
  void initState() {
    super.initState();
    final provider = Provider.of<Basicp2ViewModelScreen>(context, listen: false);


















}

 
  @override
  Widget build(BuildContext context) {
    final provider = Provider.of<Basicp2ViewModelScreen>(context, listen: false);
    return Scaffold(
      appBar: CustomAppBar(
          height: getVerticalSize(49),
          leadingWidth: 40,
          leading: AppbarImage(
              height: getSize(24),
              width: getSize(24),
              svgPath: ImageConstant.imgArrowleftBlueGray900,
              margin: getMargin(left: 16, top: 12, bottom: 13),
              onTap: () {
                Navigator.pop(context);
              }),
          centerTitle: true,
          title: AppbarTitle(text: "Update Basicp2"),        actions: [


















        ],
),
      body:  SingleChildScrollView(
        child: Padding(
          padding: const EdgeInsets.all(16),
          child: Form(
            key: _formKey,
            child: Column(
              children: [
 
            ReusableTextField(
              initialValue: widget.entity['about'],
              onSaved: (value) => widget.entity['about']= value,
              label: "Enter about",
              maxLines: 5,
            ),


            ReusableTextField(
              initialValue: widget.entity['textarea2'],
              onSaved: (value) => widget.entity['textarea2']= value,
              label: "Enter Textarea2",
              maxLines: 5,
            ),

 ReusableDatePickerField(label: 'Date Field', controller: date_field, initialDate: widget.entity['date_field'],
                                      onSaved: (value) => widget.entity['date_field'] = value,),


 ReusableDatePickerField(label: 'Date Field2', controller: date_field2, initialDate: widget.entity['date_field2'],
                                      onSaved: (value) => widget.entity['date_field2'] = value,),


 ReusableDateTimePickerField(label:'Datetime Field', controller: datetime_field, initialDateTime:widget.entity['datetime_field'] ,
                                      onSaved: (value) => widget.entity['datetime_field'] = value,),


 ReusableDateTimePickerField(label:'Datetime Field2', controller: datetime_field2, initialDateTime:widget.entity['datetime_field2'] ,
                                      onSaved: (value) => widget.entity['datetime_field2'] = value,),


  Padding(
                    padding: getPadding(top: 19),
                    child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text("Email Field",
                              overflow: TextOverflow.ellipsis,
                              textAlign: TextAlign.left,
                              style: AppStyle
                                  .txtGilroyMedium16Bluegray900),
                          CustomTextFormField(
                              hintText: "Enter Email Field",
                              initialValue: widget.entity['email_field'],
                               keyboardType: TextInputType.url,
                              errorText: _isemail_fieldEmailValid ? null : 'Please enter a valid URL',
                                onChanged: _validateemail_fieldEmail,



   // ValidationProperties

                              onsaved: (value) {
                                widget.entity['email_field'] = value;
                              },
                              margin: getMargin(top: 6))
                        ])),

SizedBox(height: 16),

  Padding(
                    padding: getPadding(top: 19),
                    child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text("Email Field2",
                              overflow: TextOverflow.ellipsis,
                              textAlign: TextAlign.left,
                              style: AppStyle
                                  .txtGilroyMedium16Bluegray900),
                          CustomTextFormField(
                              hintText: "Enter Email Field2",
                              initialValue: widget.entity['email_field2'],
                               keyboardType: TextInputType.url,
                              errorText: _isemail_field2EmailValid ? null : 'Please enter a valid URL',
                                onChanged: _validateemail_field2Email,



   // ValidationProperties

                              onsaved: (value) {
                                widget.entity['email_field2'] = value;
                              },
                              margin: getMargin(top: 6))
                        ])),

SizedBox(height: 16),



 
          CustomButton(
                  height: getVerticalSize(50),
                  text: "Update",
                  margin: getMargin(top: 24, bottom: 5),
                  onTap: () async {
                    if (_formKey.currentState!.validate()) {
                      _formKey.currentState!.save();


















       
                        try {
                        await provider.updateEntity(
                              widget.entity[
                                  'id'], // Assuming 'id' is the key in your entity map
                              widget.entity);   



















                        Navigator.pop(context);
                      } catch (e) {
                        // ignore: use_build_context_synchronously
                        showDialog(
                          context: context,
                          builder: (BuildContext context) {
                            return AlertDialog(
                              title: const Text('Error'),
                              content:
                              Text('Failed to update Basicp2: $e'),
                              actions: [
                                TextButton(
                                  child: const Text('OK'),
                                  onPressed: () {
                                    Navigator.of(context).pop();
 },
                                  ),
                                ],
                              );
                            },
                          );
                        }
                      }
                    },
                  ),
                ],
              ),
            ),
          ),
       ),
       );
  }
}